## [4.1.493] - 20221017

### 新增

1. 增加示例代码Example04，演示了如何不使用配置文件的方式创建和配置API参数；



## 修复

1. 修复冻结手续费计算时的手续费率错误问题；



## [4.1.486] - 20221013

## 优化

1. 报单插入错误回报处理优化：收到非本API报单（或协议报单）的报单插入错误回报时，自动创建XTFOrder对象，并通知用户接口；



## [4.1.479] - 20221011

## 新增

1. 持仓结构体XTFPosition增加今持仓量字段todayPosition；



## 优化

1. UDP预热报单优化；



## [4.1.475] - 20221010

## 新增

1. 增加协议方式报单的示例代码Example03，演示了如何使用API登录柜台以及使用协议方式发送报撤单；
2. 合约结构体XTFInstrument增加期权类型字段XTFOptionsType，增加获取期权对应的基础合约的接口getUnderlyingInstrument()；



## [4.1.471] - 20221008

### 优化

1. 合约结构体XTFInstrument中的expireDate字段，从int改成字符数组类型；



## [4.1.468] - 20220930

### 修复

1. 登录时偶现应答无法收到的问题；
2. 修复报单响应和报单回报乱序时，出现realChannelID字段值不一致的问题；



## [4.1.465] - 20220929

### 新增

1. 增加错误码查询接口，支持错误消息内容的中英文版本；
2. makeXTFApi()接口允许配置文件路径为空，启动API之前，通过API的setConfig()接口来设置参数；

### 优化

1. 优化资金和仓位计算；
2. XTFOrder结构体中的realChannelID字段默认为0xFF，表示无效值。当收到非0xFF时，表示realChannelI字段有效；

### 修复

1. 修复XTFOrder报单状态乱序的问题，将报单状态的顺序进行检测和约束；避免报单状态可能`先进入Queuing、PartTraded或者AllTraded，再进入Accepted状态`。
2. 修复同一API实例多次登录登出时偶先的崩溃问题；



## [4.1.454] - 20220927

### 新增
1. 数据回报处理线程增加开关配置项TCP\_WORKER\_BUSY\_LOOP\_ENABLED，如果配置为false，则不启用BusyLoop运行模式，以降低CPU核的负载。默认为true，表示启用BusyLoop运行模式。
2. XTFExchange增加字段标记是否支持席位编号IP地址查询，如果支持IP地址查询，则可以通过getChannelIP()和getChannelIPByID()接口查询IP地址。
3. XTFAccount增加最近一次本地撤单编号lastActionOrderID。

### 修复
1. 修复裸协议报单无法收到OnRsp事件的问题。



## [4.1.445] - 20220921

### 新增

1. XTFInputOrder增加minVolume字段；
2. XTFOrder增加orderMinVolume字段；



## [4.1.441] - 20220920

### 新增

1. 柜台在交易时段发生重启的通知接口`onServerReboot()`；
   1. 柜台在交易时段如果发生重启，API中断后会自动重连；
   2. 重新连接后，API会清空上一次登录的所有数据，并重新从柜台加载数据；
   3. 由于API的本地数据发生了变化，因此所有外部使用的指针数据会失效，用户需要在收到onReboot事件后，清理上一次的所有数据指针。此刻这些数据指针依然有效，当onReboot事件处理之后，数据指针将会失效。



## [4.1.437] - 20220919

### 新增

1. 配置文件标注线程的BusyLoop模式；
2. XTFExchange增加tradingDay字段；
3. XTFAccount增加lastLocalOrderID字段；

### 优化

1. 完善LocalOrderID的注释说明；



## [4.1.430] - 20220916

### 优化

1. 时间字段从整型改成字符串类型，报单增加插入日期、更新时间、撤单时间；
2. 撤单时间字段交易所暂不支持，使用最后一次更新时间来标记撤单时间；
3. 收到错误的数据包后，断开TCP连接；
4. 行情结构体未使用的字段标记说明；
5. XTFAccount接口功能添加注释说明；
6. xtf_trader_api.config TCP接收线程注释修改为回报处理线程；
7. 完善看穿式监管信息采集，如果发生错误则禁止登录；



## [4.1.425] - 20220915

### 优化

1. XTFOrder启用insertTime字段；
2. XTFOrderFilter和XTFTradeFilter增加时间字段含义的说明；



## [4.1.414] - 20220913

### 修复

1. 修复没有席位时无法获得交易所ID字符串的问题；
2. 修复realChannelID查询为0的问题；
3. onBookUpdate接口参数由引用对象改成指针对象；



## [4.1.411] - 20220909

### 新增

1. 新增onCancelOrder接口专门用于处理撤单回报的场景；

### 优化

1. onOrder接口去掉actionCode参数，移入XTFOrder结构体内部；去掉XTFError参数，改成errorCode；调整参数顺序和个数；

### 删除

1. 删除onOrder接口里撤单的相关通知；



## [4.1.398] - 20220907

### 优化

1. Example01-演示API登录登出和报单撤单功能；
2. Example02-演示使用一个简单策略基于行情驱动进行报撤单功能；



## [4.1.395] - 20220906

### 新增

1. 按条件查询报单数据的接口`findOrders()`；
2. 按条件查询成交数据`findTrades()`；

### 优化

1. 优化预热功能以提高穿透性能；
2. 优化API接口方法的注释说明；

### 修复

1. 修复login()接口登录失败的问题；
2. 修复部分报单回报没有通知回调的问题；



## [4.1.376] - 20220831

### 新增

1. 按柜台流水号撤销报单；
2. 按柜台流水号批量撤销报单；



## [4.1.372] - 20220830

### 新增

1. 初始版本功能发布。